<?php
$composer_path = '/usr/local/bin/';
$composer_executable = 'composer';

$composers = array(
	5 => 'composer1',
	10 => 'composer2',
);

$desired_version = 2;
if(is_executable($composer_path.$composer_executable)){ // Composer schon vorhanden, Version auslesen, um Symlink korrekt zu setzen
	$last_line = system("COMPOSER_ALLOW_SUPERUSER=1 ".$composer_path.$composer_executable." -V", $retval);
	if(empty($retval)){
		$last_line = trim($last_line);
		if(preg_match('/version\s+(\d+\.\d+\.\d+)/', $last_line, $matches)){
			$current_version = $matches[1];
			
			if(version_compare($current_version, '2', '<')){
				$desired_version = 1;
			}
			
			echo "Composer version ".$current_version." is already installed, will use Composer ".$desired_version." therefore.\n";
		}
	}
	unlink($composer_path.$composer_executable);
}
foreach($composers as $priority => $filename){
	system("update-alternatives --remove composer ".$composer_path.$filename." &> /dev/null"); // sicherheitshalber vorher aufräumen
	$cmd = "update-alternatives --install ".$composer_path.$composer_executable." composer ".$composer_path.$filename." ".$priority;
	system($cmd, $retval);
	if(!empty($retval)){
		echo "Failure executing command '".$cmd."'.\n";
		exit($retval);
	} else {
		echo "Executed command '".$cmd."' successfully.\n";
	}
}

$cmd = "update-alternatives --set composer ".$composer_path."composer".$desired_version;
system($cmd, $retval);
if(!empty($retval)){
	echo "Failure executing command '".$cmd."'.\n";
	exit($retval);
} else {
	echo "Executed command '".$cmd."' successfully.\n";
}

/*
composer self-update Cron deaktivieren
#Ansible: composer
15 12 1-7 * * [[ $( date '+\%u' ) == 2 ]] && /usr/local/bin/composer self-update > /dev/null 2>&1
*/
//* Root Crontab
$tmpfname = tempnam("/tmp", "crontab_");
exec('crontab -u root -l > '.escapeshellarg($tmpfname));
$existing_root_cron_jobs = file($tmpfname);

if(!empty($existing_root_cron_jobs) && is_array($existing_root_cron_jobs)){
	foreach($existing_root_cron_jobs as $key => $val) {
		if(preg_match('/^#Ansible:\s+composer/', $val)){
			unset($existing_root_cron_jobs[$key]);
			continue;
		}
		if(preg_match('@/usr/local/bin/composer\s+self\-update@', $val)){
			unset($existing_root_cron_jobs[$key]);
		}
	}
	file_put_contents($tmpfname, $existing_root_cron_jobs);
	exec('crontab -u root '.escapeshellarg($tmpfname).' &> /dev/null');
}
unlink($tmpfname);

// self-destroy
unlink(__FILE__);
exit(0);